//2401 see Fundament\other.cpp
#define WIN_SPECIFIC
#ifdef WIN_SPECIFIC
	#include <windows.h> //not #include <Stringapiset.h>
#endif
#include <codecvt>
#include <io.h>
#include <fcntl.h>

using std::cout;
using std::endl;
using std::wcout;


void TestUnicode()
{
	cout << "TestUnicode entered" << endl;
#ifdef WIN_SPECIFIC
	_setmode(_fileno(stdout), _O_U16TEXT);
	wchar_t wcZeroWithCross = L'\u0444';
	wcout << L"wcZeroWithCross = " << wcZeroWithCross << endl;
	const wchar_t* wcAscii = L"wcAscii";
	const wchar_t* wcZhongInChnHardCode = L"\u4E2D";
	const char8_t* char8ZhongInChn = u8"\u4E2D"; //not u8"\xe4\xb8\xad"; which is what's in char8ZhongInChn. [0] == 228 = E4
	const char* charZhongInChn1 = reinterpret_cast<const char*>(char8ZhongInChn); //not static_cast  charZhongInChn1[0]==-61 which is wrong
	char charZhongInChn2[4] = "\xe4\xb8\xad"; //charZhongInChn2[0]==-28==228==e4
	int wchars_num1 = MultiByteToWideChar(CP_UTF8, 0, charZhongInChn1, 3, NULL, 0);
	int wchars_num2 = MultiByteToWideChar(CP_UTF8, 0, charZhongInChn2, -1, NULL, 0);
	assert(wchars_num1 = wchars_num2);
	wchar_t* wstr1 = new wchar_t[wchars_num1];
	MultiByteToWideChar(CP_UTF8, 0, charZhongInChn1, -1, wstr1, wchars_num1);
	std::wstring wcZhongInChn1{ wstr1 };
	delete[] wstr1;
	wchar_t* wstr2 = new wchar_t[wchars_num2];
	MultiByteToWideChar(CP_UTF8, 0, charZhongInChn2, -1, wstr2, wchars_num2);
	std::wstring wcZhongInChn2{ wstr2 }; //228=E4 184=b8 173=ad
	delete[] wstr2;
	wcout << "wcAscii = " << wcAscii << ", " << "wcZhongInChnHardCode = " << wcZhongInChnHardCode << endl;
	wcout << "wcZhongInChn1 = " << wcZhongInChn1 << ", " << "wcZhongInChn2 = " << wcZhongInChn2 << endl ;
	assert(wcZhongInChn2 == std::wstring(wcZhongInChnHardCode)); //fail: assert(wcZhongInChn2 == wcZhongInChnHardCode);
	_setmode(_fileno(stdout), _O_TEXT);
	cout << "TestUnicode exit" << endl;
#else
	cout << "TestUnicode only works under windows so far" << endl;
#endif	
}

//placement new, 2403, see cpp.c
//new and delete
//#define WXC_PLACEMENT_NEW_GLOBAL //override global new is no problem, confirmed.so that it can be use in 'new int;' //all allocation comes here, no problem.
//#define WXC_USE_DEFAULT_CLASS_PLACEMENT_NEW
//#define WXC_C2573_PLACEMENT_ERROR //since placement new, override delete doesn't work. can only manuall call dtor, class has no non-placement overload for delete me: and it has placement new
const int WXC_NEW_ONE = 1, WXC_NEW_FOUR = 4;
unsigned char aPool[64]; //8 crash. [2] already need 40
#ifdef WXC_PLACEMENT_NEW_GLOBAL
void * operator new(size_t iSize)
{
	printf("global new called\n");
	return aPool + WXC_NEW_FOUR; //can be verified by looking at MEMPOOL[4]
}
void operator delete(void* p)
{
	printf("global delete called\n");
}
#endif
class CNew
{
public:
	enum { E_CTOR = 2, E_DTOR = 3, };
	int miData;
	CNew() { miData = E_CTOR; cout << "ctor called" << endl; }
#ifdef WXC_USE_DEFAULT_CLASS_PLACEMENT_NEW
#else
	static void * operator new(size_t iSize) { cout << "new(iSize) with " << iSize << endl; return aPool; } //caller's new calls ctor after this
#endif
	void *operator new[](size_t iSize) //not passing number of elements
	{
		cout << "new[](iSize) with " << iSize << endl;
		return aPool;
	}
	static void* operator new(size_t iSize, void* pLoc) { cout << "new(iSize, pLoc) with " << iSize << " , " << pLoc << endl;	return pLoc; }
#ifdef WXC_C2573_PLACEMENT_ERROR
#else
	void operator delete(void* p) { cout << "delete(p)" << endl;} //free(p);

#endif
	void operator delete[](void * p) { cout << "delete[](p) " << p << endl; }
	void operator delete(void * p, void* pLoc) //is static. //took out warning no matching delete
	{ 
		cout << "delete(p, pLoc) " << p << " , " << pLoc << endl; 
		CNew* pC = reinterpret_cast<CNew*>(p);
		assert(pC->miData != static_cast<int>(E_DTOR));
		pC->~CNew(); //CNew:: optional
	}
	~CNew() { miData = E_DTOR;  cout << "dtor CNew" << endl; } //virtual dtor required, see TestInheritance
	virtual void Func()
	{
		this->CNew::CNew();
	}
};
struct CNewSub : public CNew
{
	void Func(int i) { printf("CNewSub::Func %d\n", i); }
};
struct CNew2
{
	int miF1;
	CNew2() { miF1 = 2; } //due to pPool = 0, but only crash if this ctor exist 2402
};
void PlacementNewTest()
{
	//global standard type
	char* pPool = new char[8];
	char* pGlobal = new char('d');
	delete pGlobal;
	//base case
	CNew *a1 = new CNew;
	assert(sizeof(*a1) == 16); //iSize == 40
	assert(a1->miData == CNew::E_CTOR);
	delete a1; //error if WXC_C2573_PLACEMENT_ERROR, since it would call not-A-specific delete
	assert(a1->miData == CNew::E_DTOR); //ok since the delete not really touching/freeing the mem
	//array
	CNew *a2 = new CNew[2]; //iSize == 40, not clear
	delete []a2;
	//placement case. ?ctor called?
	CNew *a3 = new(aPool) CNew; //requires matching delete.
#ifdef WXC_C2573_PLACEMENT_ERROR
	delete a3; //calling delete(void * p) instead of delete(void * p, void* pLoc) 
#else
	CNew::operator delete(a3, aPool); //no such delete(aPool) a3;  requires CNew::operator delete so that not the clib delete. no auto call dtor.
	//delete a3; //is wrong, not going to placement delete since no where to indicate aPool
	assert(a3->miData == CNew::E_DTOR);
#endif
	CNew New;
	assert(a1->miData == CNew::E_CTOR);
	New.Func();
	CNew* pNew = new(aPool + WXC_NEW_ONE) CNew;
	assert(static_cast<void*>(pNew) == static_cast<void*>(aPool + WXC_NEW_ONE)); //vtbptr is before first data member ,  == 'a'
	pNew->Func();
#ifdef WXC_PLACEMENT_NEW_GLOBAL
	assert(aPool[WXC_NEW_FOUR] == 'd');
#endif
	CNewSub NewSub, * pNewSub = &NewSub;
	pNew = &NewSub;
	pNewSub->Func(2);
	pPool = 0;
	// CNew2* pNew2 = new(pPool)CNew2; } //#include <new> crash as expected, no standard catch for this
}

